/*
    This file is part of the tutorial in Chapter 3 of "Getting Started with Enhydra".
    It is not meant to be used in any other context.

    Simple program to test JDBC connectivity.  Assumes you have created and populated 
    a table called LE_TUTORIAL_DISCS in your database.
    Edit the connection string in the call to DriverManager.getConnection()/
    
*/

import java.sql.*;
public class JDBCTest {
	public static void main( String[] args )	{
		Connection con  = null;
		Statement  stmt = null;
		ResultSet  rs   = null;
// Load the driver, get a connection, create statement, run query, and print.
		try { 			
			Class.forName("oracle.jdbc.driver.OracleDriver");
			// Replace parameters below your database connection string, username, and password
			con = DriverManager.getConnection("jdbc:oracle:thin:@your_computer:1521:your_sid" ,"name", "pass" );
			stmt = con.createStatement();
			rs = stmt.executeQuery("SELECT * FROM LE_TUTORIAL_DISCS");
			rs.next();
			System.out.println("Title = " + rs.getString("title") + " -- Artist = " + rs.getString("artist"));
		}
		catch(ClassNotFoundException e) {
			System.err.println("Couldn't load the driver: "	+ e.getMessage());
		}
		catch(SQLException e) {
			System.err.println("SQLException caught: " + e.getMessage());
		}
	}
}