package discRack.business.person;

import discRack.business.DiscRackBusinessException;
import discRack.data.person.*;
import discRack.data.disc.DiscDO;
import discRack.business.disc.Disc;
import com.lutris.appserver.server.sql.DatabaseManagerException;
import com.lutris.appserver.server.sql.ObjectIdException;
import com.lutris.dods.builder.generator.query.DataObjectException;
        
public class Person
{
    protected PersonDO myDO = null;
    
    public Person()
        throws DiscRackBusinessException
    {
        try {
            this.myDO = PersonDO.createVirgin();
        } catch(DatabaseManagerException ex) {
            throw new DiscRackBusinessException("Error creating empty person", ex);
        } catch(ObjectIdException ex) {
            throw new DiscRackBusinessException("Error creating object ID for person", ex);
        }
    }
    
    public Person(PersonDO thePerson)
    {
        this.myDO = thePerson; 
    }
    
    public String getHandle()
        throws DiscRackBusinessException
    {
        try {
            return this.myDO.getHandle();
        } catch(DatabaseManagerException ex) {
            throw new DiscRackBusinessException("Error getting handle for person", ex);
        }
    }
    
    public String getLogin() 
        throws DiscRackBusinessException
    {
        try {
            return myDO.getLogin();
        } catch(DataObjectException ex) {
            throw new DiscRackBusinessException("Error getting user's login name", ex);
        }
    }
    
    public String getPassword() 
        throws DiscRackBusinessException
    {
        try {
            return myDO.getPassword();
        } catch(DataObjectException ex) {
            throw new DiscRackBusinessException("Error getting user's password", ex);
        }
    }
    
    public String getFirstname() 
        throws DiscRackBusinessException
    {
        try {
            return myDO.getFirstname();
        } catch(DataObjectException ex) {
            throw new DiscRackBusinessException("Error getting user's first name", ex);
        }
    }
    
    public String getLastname() 
        throws DiscRackBusinessException
    {
        try {
            return myDO.getLastname();
        } catch(DataObjectException ex) {
            throw new DiscRackBusinessException("Error getting user's last name", ex);
        }
    }
    
    public void setLogin(String login) 
        throws DiscRackBusinessException
    {
        try {
            myDO.setLogin(login);
        } catch(DataObjectException ex) {
            throw new DiscRackBusinessException("Error setting user's login name", ex);
        }
    }
    
    public void setPassword(String password) 
        throws DiscRackBusinessException
    {
        try {
            myDO.setPassword(password);
        } catch(DataObjectException ex) {
            throw new DiscRackBusinessException("Error setting user's password", ex);
        }
    }
    
    public void setFirstname(String firstname) 
        throws DiscRackBusinessException
    {
        try {
            myDO.setFirstname(firstname);
        } catch(DataObjectException ex) {
            throw new DiscRackBusinessException("Error setting user's first name", ex);
        }
    }
    
    public void setLastname(String lastname) 
        throws DiscRackBusinessException
    {
        try {
            myDO.setLastname(lastname);
        } catch(DataObjectException ex) {
            throw new DiscRackBusinessException("Error setting user's last name", ex);
        }
    }
    
    public void save() 
        throws DiscRackBusinessException
    {
        try {
            this.myDO.commit();
        } catch(Exception ex) {
            throw new DiscRackBusinessException("Error saving person", ex);
        }
    }
}