/**--------------------------------------------------------------
* discRack demo
*
* @class: PersonManager
* @version
* @author
* @since
*
*--------------------------------------------------------------*/

package discRack.business.person;

import discRack.data.person.*;
import discRack.business.DiscRackBusinessException;
import com.lutris.dods.builder.generator.query.*;
import com.lutris.appserver.server.Enhydra;
import com.lutris.logging.*;

public class PersonFactory
{
     /**
     * Gets the Person object.
     */
    public static Person findPerson(String username)
        throws DiscRackBusinessException
    {
        try {
	        PersonQuery query = new PersonQuery();
	        // To restrict the set of objects returned
	        // to the that of a certain owner set the
	        // query owner.
	        query.setQueryLogin(username);
            // Throw an exception if more than one user by this name is found
	        query.requireUniqueInstance();

	        PersonDO[] foundPerson = query.getDOArray();
	        if(foundPerson.length != 0) {
	    	    return new Person(foundPerson[0]);
            } else {
                return null;
            }
	    } catch(NonUniqueQueryException ex) {
            Enhydra.getLogChannel().write(Logger.DEBUG,
                                          "Non-unique user found in database: " +
                                          ex.getMessage());
            throw new DiscRackBusinessException("More than one user found with username: " +
                                                    username);
        } catch(DataObjectException ex) {
              throw new DiscRackBusinessException("Database error retrieving user: ", ex);
        } catch(QueryException ex) {
              throw new DiscRackBusinessException("Query exception retrieving user: ", ex);
        }

    }
}
