package discRack.presentation;

import discRack.business.person.Person;

public class DiscRackSessionData
{
    /**
     * Hash key to save session data for the DiscRack app in the Session
     */
    public static final String SESSION_KEY = "DiscRackSessionData";
    
    protected Person myUser = null;
    protected String userMessage = null;
    
    /**
     * 
     */
    public void setUser(Person thePerson)
    {
        this.myUser = thePerson;
    }
   
    /**
     * 
     */
    public Person getUser()
    {
        return this.myUser;
    }    
    
    /**
    * Method to remove the current user from the session
    */
   public void removeUser()
   {
       this.myUser = null;
   }
    
    public void setUserMessage(String msg)
    {
        this.userMessage = msg;
    }
    
    /**
     * Retrieve the most recent user message and then clear it so no
     * other app tries to use it.
     */
    public String getAndClearUserMessage()
    {
        String msg = this.userMessage;
        this.userMessage = null;
        return msg;
    }
}
